
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import "LCAUView.h"
#import "drawingFuncs.h"
#import "nxlcau2h.h"
#import <math.h>
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>

extern NXColor  colst[KK];

int    flag_prefORstas;
int    drawBack=YES;
int    drawBern=NO;
int    drawCross=NO;
int    drawMonc=NO;
int    drawEvol=NO;
int    drawLine=NO;
int    drawReturn=NO;
int    drawShort=NO;
int    drawThird=NO;
int    drawPlaid=NO;

int    drawview=0;

int    plaidline[2];

double berns[27], pasc[27];

extern double blpr[KK];			/* probability from blocks	*/
extern double stt, sta[5][K3+1];
extern char   arule[DS], arr1[AL], arr2[AL], arr3[AL];

extern char ascrule[KK][KK][KK];
extern char auxrule[KK][KK][KK];
extern  void savearry();
extern  void asctobin();
extern  void onegen(int);
extern  void renewarry();
extern  void ranlin(double);
extern  void xblnk();
extern       linix(int,int,int,int);
extern  void edijn();
extern  void edshf(int,int,int);
extern  void rule22();
extern  void evolve(int);
extern       pgrid();
extern       pprob();
extern  void procur(int,int);
extern  void twoblockfreq(int);
extern  void nblcur(int);
extern  void neisum(int,int,int);
extern  void gnlsum(int,int,int);
extern  void ijn(int,int,int);
extern  void edshg(int,int);
extern  int  nearest(double,double);
extern  void   wru(char *c); 
extern  float  getNumber(NXStream *stream);
extern  int    getSeparator(NXStream *stream);
extern  void egraf(int n);
extern  void lifreq(int n, int l);
void   serms(double x, double y, int l, int m);
void   shortevolve(int m, int n);
void   nxlcau21();
double bdist(int i, int j, int n);
void   wru(char *c);

#define MAXNUMLENGTH 50
#define DEFAULTRADIUS 1.0

@implementation LCAUView

void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {}
void videopalette(i) int i; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}
void videocattr(p,c,n,l) int p, c, n, l; {}


void videodot(i,j,l) int i, j, l; {

  if (l<2) NXSetColor(colst[l]); else NXSetColor(NX_COLORBLUE);

  switch (drawview) {
    case 0: PSrectfill((float)((2*AL-i+2*j)%(2*AL)),2.0*(float)i,1.25,1.25); break;
     case 1: PSrectfill(2.0*(float)j,200.0-2.0*(float)i,1.25,1.25); break;
     case 2: PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
     case 3: PSrectfill(4.0*(float)j+2.0,48.0-4.0*(float)i,3.0,3.0); break;
     case 4: PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
     case 5: PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
     case 6: PSrectfill(2.5*(float)j,2.5*(float)i,9.0,9.0); break;
     case 7: PSrectfill((float)j,(float)i,3.125,3.125); break;
     case 8: PSrectfill(2.0*(float)j,2.0*(float)i-196,1.25,1.25); break;
     case 9: PSrectfill((float)((i+2*j)%(2*AL)),2.0*(float)i,1.25,1.25); break;
     default: break;}
}


/*  m = line length; n = number of lines   */
/* Version for use with half-integer radii */
void shortevolve(m,n) int m, n; {
int i, j, k, l, o;
  savearry();
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
    k=j%2; l=j/2;
    for (i=0; i<m; i++) videodot(4*j,4*i-2*k,arr1[(AL+i+o+l)%AL]);
    onegen(AL);
    }
  renewarry();
}

double bdist(i,j,n) int i, j, n; {int a[10], b[10], l, m; double kay, s, t;
  kay=((double)KK);
  for (l=0; l<n; l++) a[l]=b[l]=0;
  for (m=i, l=0; l<n; m/=KK, l++) a[l]=m%KK;
  for (m=j, l=0; l<n; m/=KK, l++) b[l]=m%KK;
  for (s=0.0, t=1.0, l=0; l<n; t*=kay, l++) {if (a[l]!=b[l]) s+=t;}; 
  return s/t;
}

/* --------------------------- E V O L U T I O N --------------------------- */

- drawShEvol:sender
{   drawview=7;
    drawShort=YES;
    [theShEvolView display];
    drawShort=NO;
return self;
}

- printShEvol:sender
{ drawview=7;
  drawShort=YES;
  [self clear: self];
  [keyWindow smartPrintPSCode: self];
  drawShort=NO;
return self;
}

- drawThEvol:sender {
    [thEvolWindow makeKeyAndOrderFront: self];
    drawview=6;
    drawThird=YES;
    [thEvolWindow display];
    drawThird=NO;
return self;
}

- printThEvol:sender {
    drawview=6;
    drawThird=YES;
    [keyWindow smartPrintPSCode: self];
    drawThird=NO;
return self;
}

- printLCAU:sender {
    if (keyWindow==shEvolWindow)  [self printShEvol:  sender];
    if (keyWindow==thEvolWindow)  [self printThEvol:  sender];
    if (keyWindow==evolWindow)    [self printEvolu:   sender];
    if (keyWindow==plaidWindow)   [self printPlaid:   sender];
return self;
}

- windowDidBecomeKey:sender {
	keyWindow=sender;
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyLCAU:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: self];
	[menuPrint setAction: @selector(printLCAU:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyShEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyThEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=6;
  drawThird=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theThEvolView getBounds: &zbounds];
  [theThEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawThird=NO;
return self;
}

- copyEvolu:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyLCAU:sender {
    if (keyWindow==shEvolWindow)  [self copyShEvol: sender];
    if (keyWindow==thEvolWindow)  [self copyThEvol: sender];
    if (keyWindow==evolWindow)    [self copyEvolu:  sender];
    if (keyWindow==plaidWindow)   [self copyPlaid:  sender];
return self;
}

- drawEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
return self;
}

- printEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [keyWindow smartPrintPSCode:self];
  drawEvol=NO;
return self;
}

- drawPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
  [self clear: self];
  [self display];
  drawPlaid=NO;
  [self setFlipped: YES];
	needsClearing = YES;
return self;
}

- printPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
    [keyWindow smartPrintPSCode: self];
  drawPlaid=NO;
  [self setFlipped: YES];
	needsClearing = YES;
return self;
}


double tdist(i,j,n) int i, j, n; { int a[10], b[10], l, m; double kay, s, t, u;
	if(n>10) return 0.0;
	kay=1.0/((double)KK);
	for(l=0; l<n; l++) a[l]=b[l]=0;
	for(m=i, l=0; l<n; m/=KK, l++) a[n-l-1]=m%KK;
	for(m=j, l=0; l<n; m/=KK, l++) b[n-l-1]=m%KK;
	for(s=0.0, t=1.0, l=0; l<n; t*=kay, l++)
		{ u=a[l]-b[l]; s+=t*((u<0.0)?-u:u); }
	return s*kay;
	}



/* --------------------------- B E R N S T E I N --------------------------- */

/* - - - - doesn't really belong here - */

/* -------------------------------- L C A U -------------------------------- */

/* - - - - moved to LinePanel.m - - - - */

/* -------------------------------- A R D N -------------------------------- */

/* - - - - moved to ArdnPanel.m - - - - */

/* -------------------------------- R I J N -------------------------------- */

/* - - - - moved to LiulGuph.m - - - - */

/* -------------------------------- P R O B -------------------------------- */

/* - - - - moved to ProbView.m - - - - */

/* -------------------------------- * * * * -------------------------------- */

/* ---------------------------   L C A U    V I E W   ---------------------- */

- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	[self setRadius:DEFAULTRADIUS];
	points = [[Storage alloc]
		 initCount:0 elementSize:sizeof(NXPoint) description:"{ff}"];
	crossCursor = [NXCursor 
		 newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];
	/* 
	 * Normally, the next two message expressions would be combined, as:
	 * 		readOut = [[Cell alloc] initTextCell:""];
	 * but are here separated for clarity.
	 */
	readOut = [Cell alloc];
	[readOut initTextCell:"pointies"];
	[readOut setBezeled:YES];
	loadPSProcedures();


  /*rule22(); printf("rule22\n"); */


  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

    videocursor(0,0,0);
  //  PSshow("...LCAU21..."); 
  [self setFlipped: YES];
	return self;

}


- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML];
	unsigned int	 i, j, k=0,  n=0;/* eliminacion de m*/
        double           p, q, s, dp, pee, cue, r;
	NXPoint		 *aPoint;
	NXRect		 plotRect;
	
	if (rects == NULL) return self;

	/* 
	 * If we're printing, we need to load drawing procedures to the 
	 * printing context. This simple test is OK for a View that prints 
	 * a single page. If there were multiple pages, the procedures would 
	 * be loaded multiple times. Although this is inefficient, it causes 
	 * no error. Views that print multiple pages should load procedures 
	 * such as these in an endPrologue method (see the View spec sheet). 
	 */
	if (NXDrawingStatus != NX_DRAWING) 
		loadPSProcedures();

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	if (drawBack) NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

// drawAxes(bounds.origin.x, bounds.origin.y, bounds.size.width, bounds.size.height);


        if (drawEvol==YES) {
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
	 if ([keepTop state]){printf("savearry\n"); savearry();}
	  evolve(0);
	  if ([keepTop state]){printf("renewarry\n");renewarry();}
	  }

         if (drawShort==YES) {
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
   	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	}  

        if (drawThird==YES) {
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/10.0);
	  j=(int)(plotRect.size.height/10.0);
	  shortevolve(i,j);
	  }

/*--------------------  plaid ----------------------*/
	
	if (drawPlaid==YES) {		/* one cycle of evolution */
		printf("Hola soy plaid n: %d \n", n);
		 n=[[gridSize selectedCell] tag];		
		 if( strcmp([[aSwitch selectedCell] title], "distance")==0) {
			[ruleNumber setStringValue: "distance matrix"];
			for(i=0; i<256; i++) for(j=0; j<256; j++) {
				r= bdist(i, j, 8);
				PSsetcmykcolor(0.1*r, 0.8*r, 1.0-r, 0.55*r);
				PSrectfill((float)(j), (float)(i),1.0,1.0);
				}
			PSstroke();
			}	
		 if( strcmp([[aSwitch selectedCell] title], "circles")==0) {
			needsClearing = YES;
			[points empty];
			sprintf(c,"center : %3d,  %3d \n", plaidline[0],plaidline[1]);
			printf("center : %3d,  %3d \n", plaidline[0],plaidline[1]);
			[ruleNumber setStringValue: c];
			for(i=0; i<256; i++) for(j=0; j<256; j++) {
				p= bdist(i, plaidline[1], 8);
				q= bdist(j, plaidline[0], 8);
				s =(p+q);
				PSsetcmykcolor(s, 0.05*p, 1.0-s, 0.05*q);
				PSrectfill((float)(j), (float)(i),1.0,1.0);
				}
			PSstroke();
			PSsetgray(NX_BLACK);
			PSrectfill((float)(plaidline[0]),(float)(plaidline[1]), 2.0, 2.0);
			PSstroke();
			}				
		 if( strcmp([[aSwitch selectedCell] title], "plaid")==0) {
			printf("Opcion 3: plaid\n");
			wru(c);
			[ruleNumber setStringValue: c];
			savearry();
			asctobin();
		      	for(j=0; j<128; j++) {
				ranlin(0.5);
				for(i=0; i<64; i++) {onegen(AL); pprob(); }
				}
			renewarry();
		}
		if(n>0) {
		PSsetgray(NX_BLACK);
		PSsetlinewidth(0.0);
		    for (j=1, dp=255.0, i=0; i<n; i++) {j*=2; dp*=0.5;}
		    for (i=0, p=1.0; i<j+1; i++, p+=dp) {
			PSmoveto(0.1,p); 
			PSlineto(256.0,p);
			PSmoveto(p,0.1); //verticales
			PSlineto(p,256.0); //(pos, altura)
			}
		    PSstroke();
		    }
		}

/*------------------------------------------------*/

        if (drawLine==YES) {
        for (j=0; j<8; j++) for (i=0; i<40; i++) videodot(j,i,arr1[i+40*j]);
	}

	/* now take each point and draw it */
	PSsetgray(NX_BLACK);
	i = [points count];
	while (i--) {
		aPoint = (NXPoint *)[points elementAt:i];
		drawCircle(aPoint->x, aPoint->y, radius);
	} 
	return self;
}

- clear:sender
/*
 * Clears the LCAUView by emptying its Storage object of all points
 * and then redisplaying the LCAUView.  This action is taken only if
 * the LCAUView's state requires it.
 */
{
	if (needsClearing) {
		[points empty];
		[self display];
		needsClearing = NO;
	}
	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==6||drawview==7) 
		{[self setDrawOrigin:0 :0]; return self;}
	else 
		[self setDrawOrigin: -floor(width/2): -floor(height/2)]; 
	return self;
}

- registerPoint:(NXPoint *)aPoint
/*
 * Adds a point to the list the LCAUView keeps in its Storage object. 
 */
{
	[points addElement:aPoint];
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LCAUView updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LCAUView, the LCAUView 
 * registers the point and then sends a message to its delegate notifying it 
 * of the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect, cellRect;
   	char	buffer[100];

         double  ex, wy; /* se eliminaron var x, y, eks, wye */
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];
 	NXSetRect(&cellRect, plotRect.origin.x, plotRect.origin.y, 100.0, 20.0);

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				k=nearest(ex,wy);

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
//                ex=aPoint.x;
//                wy=aPoint.y;
		sprintf(buffer, "(%d, %d)", (int)aPoint.x, (int)aPoint.y); 
                plaidline[0]= (int)aPoint.x; 
		plaidline[1]= (int)aPoint.y;
  		[readOut setStringValue:buffer];
  		[readOut drawInside:&cellRect inView:self];
				PSsetgray(NX_BLACK);
//				PSmoveto(ex+12.0,wy);
//				PSarc(ex, wy, 12.0, 0.0, 360.0);
//				PSstroke();
//				dcntr[k][0]=ex;
//				dcntr[k][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	    	/* on mouse-up, register point, inform delegate, and clean up state */
			[readOut setStringValue:""];
  			[readOut drawInside:&cellRect inView:self];
			[window flushWindow];
			if (NXPointInRect(&aPoint, &plotRect)) {
				PSsetgray(NX_BLACK);
				drawCircle(aPoint.x, aPoint.y, radius);
				[window flushWindow];
				[self registerPoint:&aPoint];
				needsClearing = YES;
				if (delegate && [delegate respondsTo:@selector(PlotView:pointDidChange:)])
					[delegate PlotView:self pointDidChange:&aPoint];
			}
			looping = NO;
		}	
   	} while (looping && (theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

- setRadius:(float)aFloat
/*
 * Sets the value for the radius of the LCAUView's points.
 */
{
	radius = aFloat;
	return self;
}


- (float)radius
/*
 * Returns the value for the radius of the LCAUView's points.
 */
{
	return radius;
}


- read:(NXTypedStream *)stream
/*
 * Unarchives the LCAUView.  Initializes four of the LCAUView's instance 
 * variables to the values stored in the stream. 
 */
{
	[super read:stream];
	delegate = NXReadObject(stream);
	NXReadTypes(stream, "@@@f", &points, &crossCursor, &readOut, &radius);
	return self;
}

- write:(NXTypedStream *)stream
/*
 * Archives the LCAUView by writing its important instance variables to the 
 * stream. 
 */
{
	[super write:stream];
	NXWriteObjectReference(stream, delegate);
	NXWriteTypes(stream, "@@@f", &points, &crossCursor, &readOut, &radius);
	return self;
}

- awake
/*
 * Finishes initializing a LCAUView that has just been unarchived (see the 
 * read: method).
 */
{
	loadPSProcedures();
	return [super awake];
}


- (const char *)inspectorName
{
    return "LCAUViewInspector";
}

- plot:sender
/*
 * Responds to a plot: message by asking the LCAUView's delegate for a stream
 * containing the points to plot.  It then extracts number pairs from the 
 * stream and creates NXPoint structures with them.  For each structure it 
 * creates, the LCAUView sends itself a registerPoint: message to add the 
 * point to its list of points.  This simple parser ignores input it doesn't 
 * understand.
 */
{
	int	 	 c, sign, retval;
	float	 	 aNum;
	NXPoint	 	 aPoint;
	NXStream	*stream;
	BOOL		 processedLine = NO, gotFirst = NO, gotSecond = NO;
	
	if (delegate && [delegate respondsTo:@selector(PlotView:providePoints:)])
		[delegate PlotView:self providePoints:&stream];
	NXSeek(stream, 0, NX_FROMSTART);
	while ((c = NXGetc(stream)) != EOF){
		sign = 1;
		retval = getSeparator(stream);
		if (retval == 1) {
			c = NXGetc(stream);
		} else if (retval == -1) {
			break;
		}
		if (!NXIsDigit(c)) {
			if ((c == '-') && NXIsDigit(c = NXGetc(stream))){
					sign = -1;
			} else {
				while( (c != '\n') && (c != EOF)) {
					c = NXGetc(stream);
					processedLine = YES;
				}
			}
		}
		if (c == EOF)
			break;
		else if (processedLine) {
			processedLine = NO;
			continue;
		}
		aNum = getNumber(stream);
		if (!gotFirst) {
			aPoint.x = sign * aNum;
			gotFirst = YES;
		} else if (!gotSecond) {
			aPoint.y = sign * aNum;
			[self registerPoint:&aPoint];
			gotFirst = gotSecond = NO;
		} 
	}
	[self display];
	needsClearing = YES;
	return self;
}

int getSeparator(NXStream *stream)
/* 
 * Removes white space, commas, and plus signs from between 
 * number pairs.
 */
{
	int c, firstChar;
	
	NXUngetc(stream);
	c = firstChar = NXGetc(stream);
	while (NXIsSpace(c) || (c == ',') || (c == '+'))
		c = NXGetc(stream);
	/* 1 = ate something; 0 = ate nothing; -1 means EOF */
	if (c == firstChar)
		return 0;
	else if (c == EOF)
		return -1;
	NXUngetc(stream);
	return 1;
}

float getNumber(NXStream *stream)
/* 
 * Composes a floating point number from a string of number  
 * characters.
 */
{
	int c, i = 0;
	char temp[MAXNUMLENGTH];
	
	NXUngetc(stream);
	c = NXGetc(stream);
	while ((NXIsDigit(c) || (c == '.')) && (c != '\n') && (c != EOF)) {
		temp[i++] = c;
		c = NXGetc(stream);
	}
	NXUngetc(stream);
	temp[i] = 0;
	return (atof(temp));
}

@end

/* end LCAUView.m */
