
#import "RulePanel.h"
#import "nxlcau2h.h"
#import "rec.h"
#import <string.h>
#import <time.h>

extern char arule[DS], arr1[AL], arr2[AL];
extern char ascrule[KK][KK];
extern char auxrule[KK][KK];
       char gf2rule[13];		/* coefficients of GF2 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern int  binrule[KK][KK];

void    asctobin();
int     asctowol();
void	asczero();
void	auxzero();
void    clumin(char *c);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     isstot();
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(int *pr, int *br, int k);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p1,double p2);
void    ranvachrul(char *c);
void	totoasc();
int     totonu(int i);
void    ttzero();      /* DS : KK^long_vecindad */
void    wru(char *c);
void    wrru(char *c, char ru[KK][KK]);   
void	xtoasc(int n);
int 	longwolftoasc(char *c);
int     allperm(char wnum[][WNML], char ii[][KK][KK], char ru[KK][KK]); 
int 	vecperm(int ii[KK], int n); 
int     woltoasc(char as[KK][KK], int n);

/*------------ composite rule -------------*/

  void numtobin2h(int ru[KK][KK],int  n);


/*------------- definiciones de REC ----------------*/

extern struct fptbl dtbl[];
extern Inst xprg[][XLEN];
extern char idef[][30];
extern int rec_c(char *z,Inst *rprg,int l,struct fptbl dtbl[]);
extern void  chrucopy(char ii[KK][KK], char jj[KK][KK], char c);
extern int rec(char *z);


/*-----------  arithmetic rules ---------------*/

void bincopy(birular *rz, int rx[KK][KK]);
void binprint(birular rz);
void binprod(birular *rz, birular rx, birular ry);
void binsum(birular *rz, birular rx, birular ry);
void bintoasc();
void auxiliar(birular *first, int *second);
void llena_matriz(birular rx, birular ry);
int matriz[KK*KK*KK][KK*KK*KK];
int aritmetic=0;

/*------------ reversible ------------*/

void revertwo(void);
void byntoasc(char  as[KK][KK],int bi[KK][KK]);
int ufmult(void);
extern int runiq(int brul[KK][KK],int rrul[KK][KK]); 
extern int ycc(int i);

/*---------  xenophilic  y xenophobic -------------*/   

char    xp[DS] ="21221121";	             
char    xq[DS] ="13333332";	           

int permu[RSYM/2][KK] = {
			{0, 1},
			{1, 0}
			};


@implementation RulePanel

/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
//  if (strcmp(ch,"composite")==0)   [self loadLowerPanel: compRuleBox];
  if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
//  if (strcmp(ch,"product")==0)     [self loadLowerPanel: prodRuleBox];
  if (strcmp(ch,"subset")==0)      [self loadLowerPanel: subsetRuleBox];
//  if (strcmp(ch,"reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox 
{NXRect bxRect, loRect;
 id cv;
 cv=[thisRuleBox contentView];
printf("thisRuleBox title = %d\n",[[cv subviews] count]);
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=ruleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==symWindow)  nowBox=symBox;
  if (sender==toWindow)   nowBox=toBox;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- protectGenRule:sender {int i, j, k, i0, i1;
  i=j=[sender selectedCol];
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
  k=auxrule[i0][i1];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1]=!k;
return self;
}

- showSymClass:sender {
char ii[RSYM][KK][KK], wnum[RSYM][WNML]; int i, l;
  l=allperm(wnum,ii,ascrule);
  for (i=0; i<RSYM/2; i++) {
	[[symImages cellAt: i: 0] setStringValue: wnum[i]];
	[[symImages cellAt: i: 1] setStringValue: wnum[i+RSYM/2]];
	}
  [symMinimum setStringValue: wnum[l]];
return self;
}

- relatedRule:sender {
char  ii[RSYM][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int l, k, j, jj[KK];
  k= 0;
  l= allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
        if (strcmp(titl,"keep")==0)       k=0;
   else if (strcmp(titl,"complement")==0) k=1;
   else if (strcmp(titl,"cluster")==0)    k=RSYM;
   else if (strcmp(titl,"reflected")==0)  k=2;
   else if (strcmp(titl,"least")==0)      k=l;
   else if (strcmp(titl,"both")==0)       k=3;
   else					  k=0;
printf("relatedRule: k=%d\n",k);
   if (k==RSYM) {
     clumin(c);
     longwolftoasc(c);
     [self setAllRules: self];
     return self;
     }
   chrucopy(ascrule,ii[k],'w');
   [self setAllRules: self];
   if ([changeLine state]) {
	  l=vecperm(jj,k);
	  for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
	  if (l) {
		for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
		for (j=0; j<AL; j++) arr1[j]=arr2[j];
		 }
	}
return self;
}

int allperm(wn,ii,ru) char wn[][WNML], ii[][KK][KK], ru[KK][KK]; { 
int  k, l;
  chrucopy(ii[0],ru,'w'); 
  chrucopy(ii[1],ru,'y'); 
  chrucopy(ii[2],ii[0],'r');   
  chrucopy(ii[3],ii[1],'r');   
  for(k=0, l=0; k<RSYM; k++) {
    wrru(wn[k],ii[k]);
    if (strcmp(wn[k],wn[l]) < 0) l=k;
    }
  return l;
 } 

int vecperm(ii,n) int ii[KK], n; 
{  int i,k,l;
   l=!(n < 2); k=(l ? n-2: n);
   switch(k) {
        case 0 : for(i=0; i < KK ;i++) ii[i]=i; break;
        case 1 : for(i=0; i < KK ;i++) ii[i]=ycc(i); break;
        default: for(i=0; i < KK ;i++) ii[i]=i; break;  
        }
    return l;
  }

int asctowol() {return (ascrule[0][0]-'0')+KK*((ascrule[0][1]-'0')+
			KK*((ascrule[1][0]-'0')+KK*(ascrule[1][1]-'0')));}

/* turn an int decimal Wolfram number into an ascii rule */
int woltoasc(as,n) char as[KK][KK]; int n; {
int  k, i0, i1;
if (n>15) return FALSE; else k=n;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)
  {as[i0][i1]=k%KK+'0'; k/=KK;}
return TRUE;
}

/* for 2-state automata, group the neighborhoods by threes and  */
/* use ASCII letters base 2 - that is, 0-9.		*/
void wru(c) char *c; {wrru(c,ascrule);}

/* for 2-state automata, group the neighborhoods by fours and  */
/* use ASCII letters base 16 - that is, 0-9, A-F.	       */
void wrru(c,ru) char *c, ru[KK][KK]; {
int  i;
  i= 4*(2*(ru[1][1]-'0')+(ru[1][0]-'0'))+
     2*(ru[0][1]-'0')+(ru[0][0]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[WNML-2]=i;

c[WNML-1]=0;
}

/* create the rule defined by the "symmetric rule" panel */
- symRule:sender {
int j00, j01, j02, j10, j11, j12, j20, j21, j22;
int i0, i1, i2, j0, j1, r;
j00=[[s00 selectedCell] tag];
j01=[[s01 selectedCell] tag];
j02=[[s02 selectedCell] tag];
j10=[[s10 selectedCell] tag];
j11=[[s11 selectedCell] tag];
j12=[[s12 selectedCell] tag];
j20=[[s20 selectedCell] tag];
j21=[[s21 selectedCell] tag];
j22=[[s22 selectedCell] tag];
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    j0=KK+i1-i0;
    j1=KK+i2-i1;
    r =j00+j0*(j10+j0*j20)+j1*(j01+j1*j20);
    r+=j0*j1*(j11+j0*j21+j1*j12);
    r+=j0*j0*j1*j1*j22;
    switch([[sIncr selectedCell] tag]) {
      case 0: r+=i0; break;
      case 1: r+=i1; break;
      case 2: r+=i2; break;
      case 3: r+=(KK-i0)+(KK-i1); break;
      case 4: r+=(KK-i1)+(KK-i2); break;
      case 5: r+=(KK-i2)+(KK-i0); break;
      case 6: break;
      default: break;}
    ascrule[i2][i1]=r%KK+'0';
    }
  [self setAllRules: self];
  return self;
  }

- readHWRule:sender {char *c;
   c=(char *)[sender stringValue];
   if (longwolftoasc(c)) [self setAllRules: self]; 
    else  [hexRuleNumber setStringValue: "*"];
  return self;  
  }

- readDWRule:sender {
  if (woltoasc(ascrule,[sender intValue])) [self setAllRules: self]; 
    else [decRuleNumber setStringValue: "*"];
  return self;  
  }

int longwolftoasc (char *c) {
char d[WNML], e;
int i, l, n;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'f') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'F') n=e-'A'+10;
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i=0; i<WNML-1; i++) {
    n=d[WNML-2-i];
    ascrule[0][0]= '0'+n%KK; n/=KK; 
    ascrule[0][1]= '0'+n%KK; n/=KK;
    ascrule[1][0]= '0'+n%KK; n/=KK;
    ascrule[1][1]= '0'+n%KK; n/=KK;
    }
  return TRUE;
}

- readSqRule:sender {char ch[WNML]; int i, j;
   for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
	ascrule[i][j] = [[sender cellAt: i: j] intValue] + '0';
   [self setAllRules: self];
   return self;
}

- setRule:sender  {int i, ii, j, jj, i0, i1;
   printf(" setRule:sender \n ");
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  return self;
}

- twohRule:sender {int i;
  i=[sender selectedRow];
  woltoasc(ascrule,i);
  [self setAllRules: self];
return self;
}
   
- insertRule:sender {
char c[2];
int  i, j, k;
  i=[sender selectedRow];
  j=[sender selectedCol];
  k=[whichState selectedRow]+'0';
  ascrule[i][j]=k;
  c[0]=k; c[1]=0;
  [[sender selectedCell] setTitle: c];
  [self setAllRules: self];
return self;
}

- resetRuButtons:sender {int i0, i1;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    [[ruButtons cellAt: i0: i1] setTitle: ""];
    }
  [self readWRule: ruleNumber];
  [self setAllRules: self];
return self;
}

- setAllImages:sender {int i0, i1;
  asctobin();
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    [[sqascru cellAt: i0: i1] setIntValue: binrule[i0][i1]];
    }
return self;
}

- setAllRules:sender {
char   ch[WNML], ti[30];
int    i, j, i0, i1;
struct tm  *timeptr;
time_t  secsnow;

 time(&secsnow);
   timeptr = localtime(&secsnow);
   sprintf(ti,"%02d:%02d:%02d\n",
	timeptr->tm_hour, 
	timeptr->tm_min,
        timeptr->tm_sec);
   [titime setStringValue: ti];
  
  wrru(ch,ascrule);
  [hexRuleNumber setStringValue: ch];
  [decRuleNumber setIntValue: asctowol()];
  [ruleMenu selectCellAt: asctowol(): 0];
  asctobin();
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) {
    j=KK*i0+i1;
    for (i=0; i<KK; i++) {
      [[ascru cellAt: i: j] setIntValue: NO];
      if (auxrule[i0][i1]) [[ascru cellAt: i: j] setEnabled: NO];
      if (auxrule[i0][i1]) [[ascru cellAt: i: j] setBordered: NO];
      }
    [[ascru cellAt: binrule[i0][i1]: j] setIntValue: YES];
    }
  wrru(ch,ascrule);
  [hexRuleNumber setStringValue: ch];
  [decRuleNumber setIntValue: asctowol()];
  [ruleMenu selectCellAt: asctowol(): 0];
  [probView loadProb: self];
  [self setAllImages: self];
  [self showProbability: pSliders];
  if      (istot()) {asctotot(); [self setTotRules: self];}
     else [totlRef setStringValue: "Rule Type"];
return self;
}

- freeAllRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {
  granrule();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* generate a random rule */
void granrule() {int i, i0, i1;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  i=(random()&0xFF)%KK;
  ascrule[i0][i1]=i+'0';
  }
}

/* generate a random protected rule */
void granprule() {int i0, i1, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  if (i%8 == 0) j=random(); i++;
  if (auxrule[i0][i1]==0) ascrule[i0][i1]='0'+j%KK;
  j/=KK;
  }
}
   
- showProbability:sender {int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- randomline:sender
{double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1]);
return self;
}

- uniformLine:sender {ranblin(0.5,0.5); return self;}

- sCellLine:sender {putionj(1,0); return self;}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(binrule,binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/* fill ascrule from binrule */
void bintoasc() {int i0, i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    ascrule[i0][i1]=binrule[i0][i1]+'0';
}

int permut(k,n) int k, n; {
  switch (n) {
    case 0: break;
    case 1: if (k==0) k=1; else if (k==1) k=0; break;
    default: break;}
  return k;
}

/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- Demorule:sender {
printf("setDemo %2d\n",[[sender selectedCell] tag]);
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  return self;
}

/* - - - - - - - - - - - - -   G F ( 2 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf2rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf2rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
    gf2rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF2Rule:sender {
//   int i; for (i=0; i<13; i++) printf("%1d ",gf2rule[i]); printf("\n");
//    gftoasc();
//    [self setAllRules:self];
//    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmutRule: sender {
  asctobin();
  ptedbrul(binrule,binrule,[pRu intValue]);
  [self setAllRules:self];
return self;
}

void ptedbrul(pr,br,k) int *pr, *br; int k; {int i;
  for (i=0; i<DS; i++) pr[i]=permu[k][br[i]];
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- setTotalisticState:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [toWindow setDocEdited:YES];
  return self;
  }
 
- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules: self];
    [toWindow setDocEdited: NO];
return self;
}

- readTRule:sender
  {char  *c; int i, j, l, m;
     c=[sender stringValue];
     l=strlen(c); m=YES;
     if(l>TS) {[toRuleNumber setStringValue: "too long"]; return self;}
     for (j=0; j<TS; j++) ttrule[j]='0';
     for (j=0; j<l;  j++) {
       i=c[j];
       if ( i<'0' || i>'1' ) {c[j]='*'; m=NO;}
       }
     if (m) for (j=0; j<l; j++) ttrule[j]=c[j];
       else {[sender display]; return self;}
     totoasc();
     [self setTotRules: self];
     return self;
   }

/* copy ttrule */
void wtrru(c, ru) char *c, ru[TS]; {int  i;
  for (i=0; i<TS; i++) c[i]=ru[i];
  c[TS]=0;
}

- setTotRule:sender {char ch[TS+1];
  ttrule[[sender selectedCol]]=[sender selectedRow]+'0';
//  [self setTotRules: self];
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toWindow setDocEdited:YES];
  return self;
}

- setTotRules:sender {char ch[TS+1]; int i, j;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  [probView loadProb: self];
  if (istot()) {
	[totlRef setStringValue: "totalistic"];
	wtrru(ch,ttrule);
	[toRuleNumber setStringValue: ch];
	}
          else {
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllTotRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroTotRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranTRule:sender {char ch[TS+1]; int i, j, k;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setIntValue: NO];
    k=random()%KK;
    ttrule[j]=k+'0';
    [[toascru cellAt: k: j] setIntValue: YES];
    }
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toRuleNumber selectText: self];
  [toWindow setDocEdited:YES];
return self;
}

- ranPTotRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* generate a random protected rule */
void granptotrule() {int i0, i1, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++) {
          if (i%8 == 0) j=random();  i++;
  	      if (auxrule[i0][i1]==0) 
		  ascrule[i0][i1]='0'+j%KK;
  j/=KK;
  }
}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophilic:sender {
//  oxtoasc(xr);
  ranvachrul(xp);
  [self setAllRules: self];
return self;
}

- xenophobic:sender {
//  oxtoasc(xr);
  ranvachrul(xq);
  [self setAllRules: self];
return self;
}

int ran2of3(a,b) int a, b; {
if ((random()%1001)<500) return a; else return b;
}

int ran3of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
return c;
}

/* generate a random variable choice rule */
void ranvachrul(c) char *c; {int i0, i1, i;
i=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  switch (c[KK*i0+i1]-'0') {
    case 0: break;
    case 1: i=0; break;
    case 2: i=1; break;
   /* case 3: i=2; break;*/
    case 3: i=ran2of3(0,1); break;
   /* case 5: i=ran2of3(1,2); break;
    case 6: i=ran2of3(2,0); break;
    case 7: i=ran3of3(0,1,2); break;*/
    default: i=0; break;}
    ascrule[i0][i1]='0'+i;
  }
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
id  z;
int i0, i1;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
    [z setIntValue: ascrule[i0][i1]-'0'];
    z=[z nextText];
    }    
return self;
}

- enterDesign:sender {
int i, k, i0, i1, i2;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1]=(k<KK?k:0)+'0';
    auxrule[i0][i1]=(k<KK?1:0);
    }
  [self setAllRules: self];
return self;
}

/********* A RI T H M E T I C  C O M B I N A T I O N *********/

- arithmCombs:sender {return self;}

- initTwoRules:sender { char ch[4];
    granrule();
    wrru(ch,ascrule);
    [[twoRules cellAt: [sender selectedRow]: 0 ]  setStringValue: ch];
    return self;
  }

/* copy one binary rule from another */
void bincopy(rz,rx) birular *rz; int rx[KK][KK];
{int i0, i1;
for(i0=0; i0<KK; i0++) for(i1=0; i1<KK; i1++) 
	rz->two[i0][i1]= rx[i0][i1]; }

/* sum two binary rules mod KK */
void binsum(rz,rx,ry) birular *rz, rx, ry;
{int i; for(i=0; i<K3; i++) rz->one[i]=(rx.one[i]+ry.one[i])/KK;}

/* multiply two binary rules mod KK */
void binprod(rz,rx,ry) birular *rz, rx, ry;
{int i; for(i=0; i<K3; i++) rz->one[i]=(rx.one[i]*ry.one[i])/KK;}
 
/* print a binary rule (all 8 numbers) */
void binprint(rz) birular rz; 
{int i; for(i=0; i<KK*KK*KK; i++) printf("%c\n",rz.one[i] + '0'); 
   }
 
 /******** make a list of the reversible rules ********/

void revertwo(void) {
char chb[3], chc[3];
char ii[RSYM][KK][KK], wnum[RSYM][WNML];
char asqrule[KK][KK], bsqrule[KK][KK]; 
int kay[KK];
int  brul[KK][KK];
int  crul[KK][KK];
int  i00,i01,i10,i11;
int i, k, kk, l, m, mm;
printf("hello from rever \n");
k=kk=l=m=0;
for(i=0; i<KK; i++) kay[i]=0;
i=0;
printf("reversibles - unicycles \n");
for(i00=0; i00 < KK; i00++) { brul[0][0] = i00;
      if(kay[i00] > (KK*KK)) break; kay[i00]++;
for(i11=0; i11 < KK; i11++) { brul[1][1] = i11;
      if(i11 == i00) continue;
      if(kay[i11] > (KK*KK)) break; kay[i11]++;

printf("reversibles - bicycles \n");
for(i10=0; i10 < KK; i10++) { brul[0][1] = i10;
      if(kay[i10] > (KK*KK)) break; kay[i10]++;

printf("reversibles - tricycles \n");
for(i01=0; i01 < KK; i01++) { brul[0][0] = i01;
      if(kay[i01] > (KK*KK)) break; kay[i01]++;

      kk++;
if(runiq(brul,crul)) {
        byntoasc(asqrule,brul);
        byntoasc(bsqrule,crul);
        mm = allperm(wnum, ii, asqrule);
        wrru(chb, asqrule);
        wrru(chc, bsqrule);
        printf(" runiq: %s      %s     %s   (%d)/%d \n",
		 wnum[mm],chb, chc, ++k, kk);
        kk=0; }

kay[i01]--;}
kay[i10]--;}
kay[i11]--;}
kay[i00]--;}
 }

 /*  fill ascrule from binrule */
void byntoasc(as, bi) char  as[KK][KK]; int bi[KK][KK];
{ int i0, i1;
   for(i0=0; i0 < KK; i0++)
   for(i1=0; i1 < KK; i1++)
     as[i0][i1] = bi[i0][i1] + '0';
   }


int ufmult(void) {
  int j, j0, j1, j2, m[KK];
   asctobin();
   for(j=0; j < KK; j++)  m[j]=0;
   for(j0=0; j0 < KK; j0++)
   for(j1=0; j1 < KK; j1++)
   for(j2=0; j2 < KK; j2++)
     m[binrule[j0][j1]]++;
   for(j=1; j < KK; j++) if(m[j] != m[0]) return 0;
return 1;
 }

 /*------------ REC can create an initial line ---------------*/

- useRECLine:sender {
  [RECPanel makeKeyAndOrderFront : sender];
  [RECValue setStringValue : " * "];
  return self;
  }

- runRECLine:sender; {
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) {
     [RECValue setStringValue: "T"];
     [self setAllRules: self];
     }
  else
    [RECValue setStringValue: "F"];
  return self;
}

/*------------- C O M P O S I T E   R U L E ---------------*/ 
 

   - composRule:sender
  { int ru1, ru2, i0, i1, br1[KK][KK], br2[KK][KK];
     ru1=[[composRuleNumb cellAt: 0: 0] intValue];
     ru2=[[composRuleNumb cellAt: 1: 0] intValue];
     numtobin2h(br1, ru1);
     numtobin2h(br2, ru2);
     for(i0=0; i0<KK; i0++) for(i1=0; i1<KK; i1++)
       ascrule[i0][i1]= br2[br1[i0][i1]][0] + '0';
     [self setAllRules: self];
     return self;
    }

   - compxRule:sender {int i;
      i= [[composRuleNumb cellAt: 0: 0] intValue];
      [[composRuleNumb cellAt: 0: 0] setIntValue :
                       [[composRuleNumb cellAt: 1: 0] intValue]];
     [[composRuleNumb cellAt: 1: 0] setIntValue: i];
     return self;
     }

   - comprRule:sender {
       [[composRuleNumb cellAt: 0: 0] setIntValue: random()% 16];
       [[composRuleNumb cellAt: 1: 0] setIntValue: random()% 16];
      return self;
      }

   void numtobin2h(ru, n) int ru[KK][KK], n;
  { int i, j, i0, i1;
    i=n;
      for(i0=0; i0<KK; i0++) for(i1=0; i1<KK; i1++) {
        j=i%KK; i/=KK;
        ru[i0][i1] = j;
        }
    }

@end

/* end RulePanel.m */
