
/* nxlcau2h.h			*/
/* header for nxlcau2h.c	*/
/* 5 October 1989		*/

# define XLEN	   128		/* buffer length for rec predefined	*/
# define CLEN	   300  	/* buffer length for rec source		*/
# define PLEN	   900		/* buffer length for rec object		*/
# define NY	    16		/* number of demonstrations		*/
# define NRR	     7		/* number of reversible rule classes	*/

# define COLGRAF     4  	/* graph resolution			*/
# define T80X25      3  	/* text resolution			*/
# define WHCYMAG     1 		/* color quad for normal screen		*/
# define YELREGR     2  	/* color quad for alternative screen	*/
# define TRR	    16  	/* row showing totalistic rule number	*/
# define TRC	    56  	/* column for totalistic rule number	*/
# define XRR	    12  	/* row displaying totalistic rule	*/
# define XRC	    56  	/* column for totalistic rule		*/
# define AL        320  	/* array length (screen width)		*/
# define SL	    40		/* short array length			*/
# define TS	     3		/* distinct sums w/totalistic rule	*/
# define DS	     4  	/* (number of distinct neighborhoods)	*/
# define KK	     2  	/* number of states per cell		*/
# define RR	     2  	/* length of neighborhood = 2r+1	*/ 
# define SS ((RR-1)*(KK-1)+1) 	/* distinct sums w/stotalistic rule	*/
# define DN         KK		/* number of distinct nodes		*/
# define BD	    11  	/* maximum degree of b.p.		*/
# define PDN	     4  	/* nodes in pair diagram = KK^4r	*/
# define SDN	     4  	/* nodes in subset diagram = 2^(KK^2r)	*/

# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3  (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define AV	   (KK)
# define HH	    60		/* points in histogram */

# define CCY         12		/* circumference of max length cycle	*/
# define XCY	   4096		/* max number of cycles = KK^CCY	*/

# define XDB	   1024		/* max dimension de Bruijn diagram	*/

# define RSYM	     4		/* number of symmetries of rule = 2k!	*/
# define WNML	     2		/* arry size to hold septavigentesimal  */

# define CLEN 300	/* buffer length for rec source     */
# define PLEN 900	/* buffer length for rec object     */
# define XLEN 128	/* buffer length for rec predefined */

typedef union birular {
	int one[KK*KK];
	int two[KK][KK];} birular;
typedef union parneih {
	int one[K2];
	int two[KK][KK];} parneih;
typedef union twoparn {
	int one[K4];
	int two[K2][K2];
	int four[KK][KK][KK][KK];} twoparn;

/* end nxlcau2h.h*/
